package tw.edu.scu.csim.money;

import java.util.ArrayList;
import java.util.Random;

import android.app.Activity;
import android.app.Dialog;
import android.content.Context;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.Paint;
import android.graphics.drawable.BitmapDrawable;
import android.os.Bundle;
import android.os.CountDownTimer;
import android.util.DisplayMetrics;
import android.view.MotionEvent;
import android.view.ScaleGestureDetector;
import android.view.SurfaceView;
import android.view.View;
import android.view.Window;
import android.view.WindowManager;
import android.view.View.OnClickListener;
import android.widget.Button;

public class Game extends Activity {
	private int						screenWidth, screenHeight;				// ùe
	private int						level		= 10;						// r
	private int						speed		= 5;						// Ut
	private int						score		= 0;						// 
	private float					mScaleFactor;
	private ScaleGestureDetector	mScaleDetector;
	private Canvas					canvas;
	private ArrayList<Bill>			bills		= new ArrayList<Bill>();
	private MyCountDown				cdTimer;								// ˼ƭpɾ
	private String					remainingTime;							// Ѿlɶ
	Thread							mainLoop;
	BillMove						billMove;								// 渨Uʧ@
	private boolean					terminate	= false;					// BzThread

	/* eøXPĲIƥ */
	class MySurfaceView extends SurfaceView implements Runnable {
		BitmapDrawable	background;
		Paint			paint	= new Paint();

		public MySurfaceView(Context context) {
			super(context);

			/* oùe */
			DisplayMetrics dm = new DisplayMetrics();
			getWindowManager().getDefaultDisplay().getMetrics(dm);
			screenWidth = dm.widthPixels;
			screenHeight = dm.heightPixels;

			/* ]wI */
			Bitmap bitmap = BitmapFactory.decodeResource(context.getResources(), R.drawable.grid);
			background = new BitmapDrawable(context.getResources(), bitmap);
			background.setBounds(0, 0, screenWidth, screenHeight);

			paint.setColor(Color.BLACK);
			paint.setTextSize(18);

			initilizeGame(context); // HmϤm

			mScaleDetector = new ScaleGestureDetector(context, new ScaleListener());
			mScaleFactor = screenHeight; // ]սd

			mainLoop = new Thread(this);
			mainLoop.start();
		}

		/* eøX */
		void doDraw() {
			canvas = getHolder().lockCanvas();
			if (canvas != null) {
				background.draw(canvas);

				for (int i = 0; i < bills.size(); i++) {
					Bitmap bitmap = bills.get(i).bitmap;
					int left = bills.get(i).left;
					int top = bills.get(i).top;

					canvas.drawBitmap(bitmap, left, top, null);
				}
				
				String s = "ìG" + String.valueOf(score);
				canvas.drawText(s, 5, 40, paint); // eX
				canvas.drawText(remainingTime, 5, 20, paint); // eXѾl
				getHolder().unlockCanvasAndPost(canvas);
			}
		}

		public void run() {
			while (!terminate) {
				doDraw();
			}
		}

		/* ĲIƥ */
		@Override
		public boolean onTouchEvent(MotionEvent ev) {
			mScaleDetector.onTouchEvent(ev); //  ScaleGestureDetector ˬdҦƥ

			final int action = ev.getAction();
			switch (action & MotionEvent.ACTION_MASK) {
				case MotionEvent.ACTION_UP: {
					final float x = ev.getX();
					final float y = ev.getY();

					for (int i = 0; i < bills.size(); i++) {
						Bitmap bitmap = bills.get(i).bitmap;
						int range = Math.max(bitmap.getWidth(), bitmap.getHeight()) / 2; // ]wd

						int dollar = bills.get(i).dollar;
						int left = bills.get(i).left - range;
						int top = bills.get(i).top - range;
						int right = bills.get(i).left + bitmap.getWidth() + range;
						int bottum = bills.get(i).top + bitmap.getHeight() + range;

						// ˬdIO_brW
						if (x >= left && x <= right && y >= top && y <= bottum && mScaleFactor != 0) {
							score += dollar; // [
							bills.set(i, ResetBill());
						}
					}

					mScaleFactor = 0; // ]սd					
					break;
				}
			}
			return true;
		}

		/* ʧ@(Y) */
		private class ScaleListener extends ScaleGestureDetector.SimpleOnScaleGestureListener {
			@Override
			public boolean onScale(ScaleGestureDetector detector) {
				mScaleFactor = detector.getCurrentSpan(); // oثeIZ
				invalidate();
				return true;
			}
		}
	}

	/* rUt */
	class BillMove extends Thread {
		void doMove() {
			for (int i = 0; i < bills.size(); i++) {
				bills.get(i).top += speed; // UT
				// m]Xer
				if (bills.get(i).top > screenHeight) {
					bills.set(i, ResetBill());
				}
			}

			try {
				Thread.sleep(40); // mstv
			} catch (Exception ex) {
			}
		}

		public void run() {
			while (!terminate) {
				doMove();
			}
		}
	}

	/* ˼ƭpɾ */
	public class MyCountDown extends CountDownTimer {
		Context	context;

		public MyCountDown(long millisInFuture, long countDownInterval, Context context) {
			super(millisInFuture, countDownInterval);
			this.context = context;
		}

		@Override
		public void onFinish() {
			remainingTime = "Ѿlɶ: 0 ";

			Button button = new Button(context);
			button.setText("Tw");
			final Dialog dialog = new Dialog(context);
			dialog.setTitle("ߧAo " + score + "I");
			dialog.setContentView(button);
			dialog.show();
			button.setOnClickListener(new OnClickListener() {
				public void onClick(View v) {
					dialog.dismiss();
					Game.this.finish();
				}
			});
			
			terminate = true;
			mainLoop.interrupt();
			billMove.interrupt();
		}

		@Override
		public void onTick(long millisUntilFinished) {
			remainingTime = "Ѿlɶ: " + (millisUntilFinished / 1000 + 1) + " ";
		}
	}

	/* NϭsbeWHm */
	private void initilizeGame(Context context) {
		bills.clear();

		for (int i = 0; i < level; i++) {
			Bill bill = ResetBill();
			bills.add(bill);
		}

		score = 0; // m

		cdTimer = new MyCountDown(60000, 500, context); // ˼ƭpɾ
		cdTimer.start();

		billMove = new BillMove(); // BzrʪThread
		billMove.start();
	}

	/* Hͤ@ir */
	private Bill ResetBill() {
		Random r = new Random();

		Bitmap bitmap;
		int dollar = 100;
		int j = r.nextInt(100);
		if (j < 70) {
			// 100
			bitmap = BitmapFactory.decodeResource(this.getResources(), R.drawable.bill100);
		} else if (j < 90) {
			// 500
			dollar = 500;
			bitmap = BitmapFactory.decodeResource(this.getResources(), R.drawable.bill500);
		} else {
			// 1000
			dollar = 1000;
			bitmap = BitmapFactory.decodeResource(this.getResources(), R.drawable.bill1000);
		}

		int left = r.nextInt(screenWidth - bitmap.getWidth());
		int top = 0 - bitmap.getHeight() - r.nextInt(screenHeight) * 2;
		Bill bill = new Bill(bitmap, dollar, left, top);

		return bill;
	}

	@Override
	protected void onCreate(final Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		requestWindowFeature(Window.FEATURE_NO_TITLE);
		getWindow().setFlags(WindowManager.LayoutParams.FLAG_FULLSCREEN, WindowManager.LayoutParams.FLAG_FULLSCREEN);
		setContentView(new MySurfaceView(this));
	}

	@Override
	protected void onDestroy() {
		super.onDestroy();
		terminate = true;
		mainLoop.interrupt();
		billMove.interrupt();
		cdTimer.cancel();
	}
}
